softwaretype<-NA

#parameters of the process to invoke
false<-F
true<-T
softwaretype<-'Pre-Installed'
softwareName<-'diffbasic.sh'
operator<-"diff|sdiff"
cat('Input Parameter:operator',operator,'\n')
options<-"-u"
cat('Input Parameter:options',options,'\n')
file1<-"file1"
cat('Input Parameter:file1',file1,'\n')
file2<-"file2"
cat('Input Parameter:file2',file2,'\n')
overallInput<-'operator	options	file1	file2'
overallInputValues<-paste(operator,options,file1,file2,sep='	')
overallInputTypes<-'Enumerated	String	File	File'



external_process_to_invoke<-'diffbasic.sh' #can be a python, fortran, linux-compiled, octave, java process
#prepare the command to invoke
command = paste(external_process_to_invoke,paste('"',operator,'"',sep=''),paste('"',options,'"',sep=''),paste('"',file1,'"',sep=''),paste('"',file2,'"',sep=''),sep=" ")
cat('Command:',command,'\n')



cat("Adding rights to the files\n")
logs<-system("chmod 755 *", intern = TRUE)
cat("computation started\n")
cat("software type:",softwaretype,"\n")
#run the process
if (is.na(softwaretype)){
}else if (softwaretype=='Windows-compiled'){
	cat("Windows computation\n")
	command<-paste('mono ./',command,sep='')
}else if (softwaretype=='Linux-compiled'){
	cat("Linux computation\n")
	command<-paste('./',command,sep='')
}else if (softwaretype=='Pre-Installed'){
	cat("Pre-installed computation\n")
	command<-paste('./',command,sep='')
}else if (softwaretype=='R-blackbox'){
	cat("R computation\n")
	command<-paste('Rscript --vanilla ',command,sep='')
}else if (softwaretype=='Python'){
	cat("Python computation\n")
	command<-paste('python -m ',command,sep='')
}else if (softwaretype=='Java'){
	cat("Java computation\n")
	command<-paste('java -cp ./',command,sep='')
}else if (softwaretype=='Octave'){
	cat("Octave computation\n")
	command<-paste('octave ./',command,sep='')
}else if (softwaretype=='Knime-Workflow'){
  cat("Knime computation\n")
  workflow<-"workflow.zip"
  if (file.exists(paste(softwareName,'.zip',sep='')))
    file.rename(paste(softwareName,'.zip',sep=''),softwareName)
  #EXAMPLE: knime -reset -consoleLog -nosplash -application org.knime.product.KNIME_BATCH_APPLICATION 
  #-workflowFile=SimpleSample.knwf -destFile=out.zip -workflow.variable=test,"besttest",String
  oI<-strsplit(overallInput,"\t")
  oIv<-strsplit(overallInputValues,"\t")
  oIt<-strsplit(overallInputTypes,"\t")

  knimevariables<-""
  for (i in 1:length(oI[[1]])){
		oinp<-oI[[1]][i]
		oinpv<-oIv[[1]][i]
		oinpt<-oIt[[1]][i]
		if (tolower(oinpt) == 'integer')
			oinpt<-"int"
		else if (tolower(oinpt) == 'double')
			oinpt<-"double"
		else {
			oinpv<-gsub(' ', '_', oinpv)
			oinpv<-gsub(',', ';', oinpv)
			oinpt<-"String"
		}
		
		knimevar = paste(oinp,",",'"',oinpv,'"',",",oinpt,sep="")
		
		knimevariables<-paste(knimevariables,' -workflow.variable=',knimevar,sep="")
		
	}
  command<-paste('/usr/local/bin/knime-full -reset -consoleLog -nosplash -application org.knime.product.KNIME_BATCH_APPLICATION -workflowFile=',softwareName,' -destFile=',workflow,knimevariables, sep='')
}
	
cat(command,"\n")
logs<-system(command, intern = TRUE)
cat("computation finished\n")
cat("Logs of the computation\n")
print(logs)
cat("\n")


#prepare the final output file
outputfolder <- getwd() #current working folder (a temporary folder is created at each run and set as working directory)
output<-"output.txt"
#fixed code to add some randomness to the output file name and save concurrent requests
output<-paste(output,'_',Sys.time(),sep='')
output<-gsub(' ', '_', output)
output<-gsub(':', '_', output)
file.rename('output.txt',output)
cat('Output Parameter:output',output,'\n')



#check if the output exists before exiting
fexists = file.exists(paste(output,sep=''))
cat("file output exists?",fexists,"\n")
if (!fexists){
	cat(fexists,"Error, the output output(output.txt) does not exist!\n")
	stoptheprocess
}


