package org.gcube.dataanalysis.executor.rscripts;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import org.gcube.dataanalysis.ecoengine.datatypes.PrimitiveType;
import org.gcube.dataanalysis.ecoengine.datatypes.StatisticalType;
import org.gcube.dataanalysis.ecoengine.datatypes.enumtypes.PrimitiveTypes;
import org.gcube.dataanalysis.executor.rscripts.generic.GenericRScript;
import org.gcube.dataanalysis.ecoengine.utils.DynamicEnum;
import java.lang.reflect.Field;

public class DiffBasic extends GenericRScript {

	static class opIO13985ca0347884f45a38ccc7fd1396679 extends DynamicEnum {
		public enum EopIO13985ca0347884f45a38ccc7fd1396679 {};
		public Field[] getFields() {
			Field[] fields = EopIO13985ca0347884f45a38ccc7fd1396679.class.getDeclaredFields();
			return fields;
		}
	}

	@Override
	public String getDescription() {
		return "The basic diff and sdiff linux command line";
	}

	protected void initVariables(){
		mainScriptName="DiffBasic/Main.R";
		packageURL="http://data.d4science.org/dlMxa1U3d2FWRDFMZzYydnA2NXFzcGtZYWtvMUhvWlBHbWJQNStIS0N6Yz0";
		environmentalvariables = new ArrayList<String>();
		inputvariables.add("operator");
		inputvariables.add("options");
		inputvariables.add("file1");
		inputvariables.add("file2");
		outputvariables.add("output");
	}

	@Override
	protected void setInputParameters() {
		if (org.gcube.dataanalysis.executor.rscripts.DiffBasic.opIO13985ca0347884f45a38ccc7fd1396679.EopIO13985ca0347884f45a38ccc7fd1396679.values().length==0){
			opIO13985ca0347884f45a38ccc7fd1396679 en = new opIO13985ca0347884f45a38ccc7fd1396679();
			en.addEnum(org.gcube.dataanalysis.executor.rscripts.DiffBasic.opIO13985ca0347884f45a38ccc7fd1396679.EopIO13985ca0347884f45a38ccc7fd1396679.class, "diff");
			en.addEnum(org.gcube.dataanalysis.executor.rscripts.DiffBasic.opIO13985ca0347884f45a38ccc7fd1396679.EopIO13985ca0347884f45a38ccc7fd1396679.class, "sdiff");
		}

		addEnumerateInput(org.gcube.dataanalysis.executor.rscripts.DiffBasic.opIO13985ca0347884f45a38ccc7fd1396679.EopIO13985ca0347884f45a38ccc7fd1396679.values(), "operator", "Operator diff or sdiff", "diff");
		inputs.add(new PrimitiveType(String.class.getName(), null,PrimitiveTypes.STRING, "options", "Use for example -u for diff and -a for sdiff", "-u"));
		inputs.add(new PrimitiveType(File.class.getName(), null,PrimitiveTypes.FILE, "file1", "First file for comparison", "file1"));
		inputs.add(new PrimitiveType(File.class.getName(), null,PrimitiveTypes.FILE, "file2", "Second file for comparison", "file2"));
	}

	@Override
	public StatisticalType getOutput() {
		output.put("output",new PrimitiveType(File.class.getName(), new File(outputValues.get("output")), PrimitiveTypes.FILE, "output", "output"));
		PrimitiveType o = new PrimitiveType(LinkedHashMap.class.getName(), output, PrimitiveTypes.MAP, "Output", "");
		return o;
	}
}
